﻿using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Model;
using DevExpress.ExpressApp.TreeListEditors.Win;
using DevExpress.ExpressApp.Win.Controls;
using DevExpress.Persistent.Base.General;
using HierarchyNode.Module.Win.Editors;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace IHierarchyNode.Module.Win.Editors
{
    //This Editors is used for IHierarchyNode tests
    [ListEditor(typeof(ITreeNode), false)]
    public class TreeListEditor1 : TreeListEditor
    {
        public bool test;
        public TreeListEditor1(IModelListView model) : base(model)
        {
            this.DataSourceChanged += TreeListEditor1_DataSourceChanged;
        }

        Stopwatch timer;

        void TreeListEditor1_DataSourceChanged(object sender, EventArgs e)
        {
            timer = Stopwatch.StartNew();
            test = false;
        }

        //protected override object CreateControlsCore()
        //{
        //    var treeList = base.CreateControlsCore();
        //    if(treeList is ObjectTreeList)
        //    {
        //    }
        //    return treeList;
        //}

        protected override void OnControlsCreated()
        {
            base.OnControlsCreated();
            TreeList.AfterExpand += TreeList_AfterExpand;
            TreeList.BeforeExpand += TreeList_BeforeExpand;
            TreeList.BindingContextChanged += TreeList_BindingContextChanged;
            TreeList.Layout += TreeList_Layout;
            TreeList.Load += TreeList_Load;
            TreeList.NodesReloaded += TreeList_NodesReloaded;
        }
        
        void TreeList_NodesReloaded(object sender, EventArgs e)
        {
            test = false;
        }

        void TreeList_Load(object sender, EventArgs e)
        {
            test = false;
        }

        void TreeList_Layout(object sender, System.Windows.Forms.LayoutEventArgs e)
        {
            test = false;
        }

        void TreeList_BindingContextChanged(object sender, EventArgs e)
        {
            test = false; 
            var t = timer.Elapsed.TotalMilliseconds;
            MessageBox.Show(t.ToString());
        }

        void TreeList_BeforeExpand(object sender, DevExpress.XtraTreeList.BeforeExpandEventArgs e)
        {
            test = false;
            timer = Stopwatch.StartNew();
        }

        void TreeList_AfterExpand(object sender, DevExpress.XtraTreeList.NodeEventArgs e)
        {
            test = false;
            var t = timer.Elapsed.TotalMilliseconds;
            MessageBox.Show(t.ToString());
        }
    }

    [ListEditor(typeof(Xafari.Base.IHierarchyNode), false)]
    public class WinHierarchyNodeListEditor1 : WinHierarchyNodeListEditor
    {
        public WinHierarchyNodeListEditor1(IModelListView model)
            : base(model)
        {
            this.DataSourceChanged += TreeListEditor1_DataSourceChanged;
        }

        public bool test;
        Stopwatch timer;

        void TreeListEditor1_DataSourceChanged(object sender, EventArgs e)
        {
            timer = Stopwatch.StartNew();
        }

        protected override object CreateControlsCore()
        {
            return base.CreateControlsCore();
        }

        protected override void OnControlsCreated()
        {
            base.OnControlsCreated();
            TreeList.AfterExpand += TreeList_AfterExpand;
            TreeList.BeforeExpand += TreeList_BeforeExpand;
            TreeList.BindingContextChanged += TreeList_BindingContextChanged;
            TreeList.Layout += TreeList_Layout;
            TreeList.Load += TreeList_Load;
            TreeList.NodesReloaded += TreeList_NodesReloaded;
        }

        void TreeList_NodesReloaded(object sender, EventArgs e)
        {
            test = false;
        }

        void TreeList_Load(object sender, EventArgs e)
        {
            test = false;
        }

        void TreeList_Layout(object sender, System.Windows.Forms.LayoutEventArgs e)
        {
            test = false;
        }

        void TreeList_BindingContextChanged(object sender, EventArgs e)
        {
            test = false;
            var t = timer.Elapsed.TotalMilliseconds;
            MessageBox.Show(t.ToString());
        }
        void TreeList_BeforeExpand(object sender, DevExpress.XtraTreeList.BeforeExpandEventArgs e)
        {
            timer = Stopwatch.StartNew();
            test = false;
        }

        void TreeList_AfterExpand(object sender, DevExpress.XtraTreeList.NodeEventArgs e)
        {
            test = false;
            var t = timer.Elapsed.TotalMilliseconds;
            MessageBox.Show(t.ToString());
        }
    }

    [ListEditor(typeof(Xafari.Base.IHierarchyNode), false)]
    public class WinExplorerListEditor1 : Xafari.Editors.Win.WinExplorerListEditor
    {
        public WinExplorerListEditor1(IModelListView model)
            : base(model)
        {
            this.DataSourceChanged += WinExplorerListEditor1_DataSourceChanged;
        }

        void WinExplorerListEditor1_DataSourceChanged(object sender, EventArgs e)
        {
            timer = Stopwatch.StartNew();
        }

        Stopwatch timer;

        protected override void OnControlsCreated()
        {
            base.OnControlsCreated();
            this.Grid.BindingContextChanged += Grid_BindingContextChanged;
            this.CollectionSource.CriteriaApplying += CollectionSource_CriteriaApplying;
            this.CollectionSource.CriteriaApplied += CollectionSource_CriteriaApplied;
        }

        void CollectionSource_CriteriaApplied(object sender, EventArgs e)
        {
            var t = timer.Elapsed.TotalMilliseconds;
            MessageBox.Show(t.ToString());
        }

        void CollectionSource_CriteriaApplying(object sender, EventArgs e)
        {
            timer = Stopwatch.StartNew();
        }

        void Grid_BindingContextChanged(object sender, EventArgs e)
        {
            var t = timer.Elapsed.TotalMilliseconds;
            MessageBox.Show(t.ToString());
        }
    }
}
