using DevExpress.Data.Filtering;
using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Updating;
using IHierarchyNode.Module.BusinessObjects;
using System;

namespace HierarchyNode.Module.DatabaseUpdate
{
    // For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/clsDevExpressExpressAppUpdatingModuleUpdatertopic
    public class Updater : ModuleUpdater
    {
        private int count = 201;

        public Updater(IObjectSpace objectSpace, Version currentDBVersion) :
            base(objectSpace, currentDBVersion)
        {
        }

        public override void UpdateDatabaseAfterUpdateSchema()
        {
            base.UpdateDatabaseAfterUpdateSchema();
            SetTreeListObject();
            SetHierarchyNodeObject();
            SetHierarchicalClassifierItemDescendant();
            SetHierarchyNodeObjectDescendant();
        }

        private void SetHierarchyNodeObjectDescendant()
        {
            string name = "Node_0";
            HierarchyNodeDescendant theObject = ObjectSpace.FindObject<HierarchyNodeDescendant>(CriteriaOperator.Parse("Name=?", name));
            if (theObject == null)
            {
                name = "Node_";
                for (int i = 0; i < count; i++)
                {
                    theObject = ObjectSpace.CreateObject<HierarchyNodeDescendant>();
                    theObject.Name = name + i;
                    if (i >= count/2)
                        theObject.Parent = ObjectSpace.FindObject<HierarchyNodeDescendant>(CriteriaOperator.Parse("Name=?", "Node_1"));                    
                }
            }
            ObjectSpace.CommitChanges();
        }

        private void SetHierarchicalClassifierItemDescendant()
        {
            string name = "Node_0";
            HierarchicalClassifierItemDescendant theObject = ObjectSpace.FindObject<HierarchicalClassifierItemDescendant>(CriteriaOperator.Parse("Name=?", name));
            if (theObject == null)
            {
                name = "Node_";
                for (int i = 0; i < count; i++)
                {
                    theObject = ObjectSpace.CreateObject<HierarchicalClassifierItemDescendant>();
                    theObject.Name = name + i;
                    if (i >= count / 2)
                        theObject.Parent = ObjectSpace.FindObject<HierarchicalClassifierItemDescendant>(CriteriaOperator.Parse("Name=?", "Node_1"));
                }
            }
            ObjectSpace.CommitChanges();
        }

        private void SetHierarchyNodeObject()
        {
            string name = "Node_0";
            HierarchyNodeObject theObject = ObjectSpace.FindObject<HierarchyNodeObject>(CriteriaOperator.Parse("Name=?", name));
            if (theObject == null)
            {
                name = "Node_";
                for (int i = 0; i < count; i++)
                {
                    theObject = ObjectSpace.CreateObject<HierarchyNodeObject>();
                    theObject.Name = name + i;
                    if (i >= count/2)
                        theObject.Parent = ObjectSpace.FindObject<HierarchyNodeObject>(CriteriaOperator.Parse("Name=?", "Node_1")); 
                }
            }
            ObjectSpace.CommitChanges();
        }

        private void SetTreeListObject()
        {
            string name = "Node_0";
            TreeListObject theObject = ObjectSpace.FindObject<TreeListObject>(CriteriaOperator.Parse("Name=?", name));
            if (theObject == null)
            {
                name = "Node_";
                for (int i = 0; i < count; i++)
                {
                    theObject = ObjectSpace.CreateObject<TreeListObject>();
                    theObject.Name = name + i;
                    if (i >= count/2)
                        theObject.Parent = ObjectSpace.FindObject<TreeListObject>(CriteriaOperator.Parse("Name=?", "Node_1")); 
                }
            }
            ObjectSpace.CommitChanges();
        }

        public override void UpdateDatabaseBeforeUpdateSchema()
        {
            base.UpdateDatabaseBeforeUpdateSchema();
        }
    }
}
